(*
 * Copyright (c) 2000-2001 Stefan Kral
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *)

(* Unparsing of vsimd-instructions. Only useful during debugging. *)

open Util
open Number
open Variable
open VSimdBasics
open VFpUnparsing
open Printf

let vsimdregToString (V_SimdReg idx) = sprintf "vsimdreg(%d)" idx
let vintregToString  (V_IntReg idx)  = sprintf "vintreg(%d)" idx
let realimagToString = function RealPart -> "re" | ImagPart -> "im"
let vsimdposToString = function V_Lo -> "lo" | V_Hi -> "hi" | V_LoHi -> "lohi"
let vsimdposToChsconstnamestring p = "chs_" ^ vsimdposToString p
